#ifndef INOUTPORT_H_INCLUDED_
#define INOUTPORT_H_INCLUDED_

#include <vector>
#include "rose.h"

#include "port.h"

namespace risc {

class InOutPort: public Port {

public:

  /**
   * \brief default constructor
   */
  explicit InOutPort(SgVariableDefinition *ast_node);

private:
  /**
   * \brief Disabled copy constructor
   */
  InOutPort(const InOutPort &iop);
};

typedef std::vector<InOutPort*> InOutPortVector;
typedef std::vector<InOutPort*>::iterator InOutPortVectorIter;
typedef std::vector<InOutPort*>::const_iterator InOutPortVectorConstIter;

}; // end namespace risc

#endif /* INOUTPORT_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
