#ifndef INPORT_H_INCLUDED_
#define INPORT_H_INCLUDED_

#include <vector>

#include "rose.h"
#include "port.h"

namespace risc {

class InPort: public Port {

public:

  /**
   * \brief default constructor
   */
  explicit InPort(SgVariableDefinition *ast_node);

private:
  /**
   * \brief Disabled copy constructor
   */
  InPort(const InPort &ip);
};

typedef std::vector<InPort*> InPortVector;
typedef std::vector<InPort*>::iterator InPortVectorIter;
typedef std::vector<InPort*>::const_iterator InPortVectorConstIter;

}; // end namespace risc

#endif /* INPORT_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
