#ifndef INTERNAL_REPRESENTATION_HELPER_H_INCLUDED_
#define INTERNAL_REPRESENTATION_HELPER_H_INCLUDED_

/*
 * ----------------------------------------------------------------------------
 # Makefile.macros: global definitions for all Makefiles
 # ----------------------------------------------------------------------------
 #
 # Modifications: (most recent first)
 #
 # TS 03/16/16   version 0.0, added function to find module definition by name
 # ----------------------------------------------------------------------------
 */

#include <iostream>

namespace risc {

class Module;
class HierarchicalChannel;

/**
 * \fn       find_module_definition
 * \brief    This function searches for module definition with the name 'name'.
 *           The name is the mangled name of the class.
 */
Module* find_module_definition(std::string name);

/**
 * \fn       find_hierarchical_channel_definition
 * \brief    This function searches for module definition with the name 'name'.
 *           The name is the mangled name of the class.
 */
HierarchicalChannel*
find_hierarchical_channel_definition(std::string name);
};


#endif /* INTERNAL_REPRESENTATION_HELPER_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
