#ifndef OUTPORT_H_INCLUDED_
#define OUTPORT_H_INCLUDED_

#include <vector>

#include "rose.h"
#include "port.h"

namespace risc {

class OutPort: public Port {

public:

  /**
   * \brief default constructor
   */
  explicit OutPort(SgVariableDefinition *ast_node);

private:
  /**
   * \brief Disabled copy constructor
   */
  OutPort(const OutPort &op);
};

typedef std::vector<OutPort*> OutPortVector;
typedef std::vector<OutPort*>::iterator OutPortVectorIter;
typedef std::vector<OutPort*>::const_iterator OutPortVectorConstIter;

}; // end namespace risc

#endif /* OUTPORT_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
