#include "systemc.h"

class DecomposerZ1: public sc_module {

public:
  SC_HAS_PROCESS(DecomposerZ1);

  DecomposerZ1(sc_module_name mn):
    sc_module(mn)
  { }

  int decomposer_z1_1_int()
  {
    int begin_decomposer_z1_1;
    wait();
    int end_decomposer_z1_1;
    return 4;
  }

  void decomposer_z1_1_void()
  {
    int begin_decomposer_z1_1;
    wait();
    int end_decomposer_z1_1;
  }
};

class DecomposerZ: public sc_module {

public:
  SC_HAS_PROCESS(DecomposerZ);

  DecomposerZ(sc_module_name mn):
    sc_module(mn)
  { }

  int decomposer_z_1_int()
  {
    int begin_decomposer_z_1;
    wait();
    int end_decomposer_z_1;
    return 4;
  }

  void decomposer_z_1_void()
  {
    int begin_decomposer_z_1;
    wait();
    int end_decomposer_z_1;
  }
};


class DecomposerY: public sc_module {

public:
  SC_HAS_PROCESS(DecomposerY);

  DecomposerZ *dz;
  DecomposerZ1 dz1;

  DecomposerY(sc_module_name mn):
    sc_module(mn),
    dz1("dz1")
  {
    dz = new DecomposerZ("dz");
  }
};

class DecomposerX: public sc_module {

public:
  SC_HAS_PROCESS(DecomposerX);

  DecomposerY dy;

  DecomposerX(sc_module_name mn):
    sc_module(mn),
    dy("dy")
  { }
};

class Decomposer: public sc_module {
public:
  SC_HAS_PROCESS(Decomposer);

  DecomposerX dx;

  Decomposer(sc_module_name mn):
    sc_module(mn),
    dx("dx")
  {
    SC_THREAD(decomposer_1); // untested
  }

  void decomposer_1()
  {
    int m;
    int n;

    dx.dy.dz1.decomposer_z1_1_void();
    dx.dy.dz1.decomposer_z1_1_int();
    m + dx.dy.dz1.decomposer_z1_1_int() + n;
    int l1 = m + dx.dy.dz1.decomposer_z1_1_int() + n;

    dx.dy.dz->decomposer_z_1_int();
    dx.dy.dz->decomposer_z_1_void();
    m + dx.dy.dz->decomposer_z_1_int() + n;
    int l = m + dx.dy.dz->decomposer_z_1_int() + n;
  }
};


#ifndef RISC_ALL_SEGMENT_TESTS
int sc_main(int argc, char **argv)
{
  Decomposer mm("mm");

  sc_start();
  return 0;
}

#endif

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
